Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.sql
Class QSqlQuery

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.sql.QSqlQuery

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QSqlQuery

extends QtJambiObject
implements java.lang.Cloneable

The `QSqlQuery` class provides a means of executing and manipulating SQL statements. `QSqlQuery` encapsulates the functionality involved in creating, navigating and retrieving data from SQL queries which are executed on a `QSqlDatabase`. It can be used to execute DML (data manipulation language) statements, such as `SELECT`, `INSERT`, `UPDATE` and `DELETE`, as well as DDL (data definition language) statements, such as `CREATE` `TABLE`. It can also be used to execute database-specific commands which are not standard SQL (e.g. `SET DATESTYLE=ISO` for `PostgreSQL`).

Successfully executed SQL statements set the query's state to active; `isActive()` then returns true. Otherwise the query's state is set to inactive. In either case, when executing a new SQL statement, the query is positioned on an invalid record; an active query must be navigated to a valid record (so that `isValid()` returns true) before values can be retrieved. Navigating records is performed with the following functions:

- `next()`
- `previous()`
- `first()`
- `last()`
- `seek()`

These functions allow the programmer to move forward, backward or arbitrarily through the records returned by the query. If you only need to move forward through the results (e.g., by using `next()`), you can use `setForwardOnly()`, which will save a significant amount of memory overhead and improve performance on some databases. Once an active query is positioned on a valid record, data can be retrieved using `value()`. All data is transferred from the SQL backend using `QVariants`.

For example:

            QSqlQuery query = new QSqlQuery("SELECT * country FROM artist");
            while (query.next()) {
                String country = query.value(0).toString();
                doSomething(country);
            }

To access the data returned by a query, use value(int). Each field in the data returned by a `SELECT` statement is accessed by passing the field's position in the statement, starting from 0. This makes using `SELECT *` queries inadvisable because the order of the fields returned is indeterminate.

For the sake of efficiency, there are no functions to access a field by name (unless you use prepared queries with names, as explained below). To convert a field name into an index, use `record()`.`indexOf()`, for example:

            QSqlQuery query = new QSqlQuery("SELECT * FROM artist");
            int fieldNo = query.record().indexOf("country");
            while (query.next()) {
                String country = query.value(fieldNo).toString();
                doSomething(country);
            }

`QSqlQuery` supports prepared query execution and the binding of parameter values to placeholders. Some databases don't support these features, so for those, Qt emulates the required functionality. For example, the Oracle and ODBC drivers have proper prepared query support, and Qt makes use of it; but for databases that don't have this support, Qt implements the feature itself, e.g. by replacing placeholders with actual values when a query is executed. Use `numRowsAffected()` to find out how many rows were affected by a non-`SELECT` query, and `size()` to find how many were retrieved by a `SELECT`.

Oracle databases identify placeholders by using a colon-name syntax, e.g `:name`. ODBC simply uses `?` characters. Qt supports both syntaxes, with the restriction that you can't mix them in the same query.

You can retrieve the values of all the fields in a single variable (a map) using `boundValues()`.

## Approaches to Binding Values

Below we present the same example using each of the four different binding approaches, as well as one example of binding values to a stored procedure.

Named binding using named placeholders:

            QSqlQuery query = new QSqlQuery();
            query.prepare("INSERT INTO person (id, forename, surname) " +
                          "VALUES (:id, :forename, :surname)");
            query.bindValue(":id", 1001);
            query.bindValue(":forename", "Bart");
            query.bindValue(":surname", "Simpson");
            query.exec();

Positional binding using named placeholders:

            QSqlQuery query = new QSqlQuery();
            query.prepare("INSERT INTO person (id, forename, surname) " +
                          "VALUES (:id, :forename, :surname)");
            query.bindValue(0, 1001);
            query.bindValue(1, "Bart");
            query.bindValue(2, "Simpson");
            query.exec();

Binding values using positional placeholders (version 1):

            QSqlQuery query = new QSqlQuery();
            query.prepare("INSERT INTO person (id, forename, surname) " +
                          "VALUES (?, ?, ?)");
            query.bindValue(0, 1001);
            query.bindValue(1, "Bart");
            query.bindValue(2, "Simpson");
            query.exec();

Binding values using positional placeholders (version 2):

            QSqlQuery query = new QSqlQuery();
            query.prepare("INSERT INTO person (id, forename, surname) " +
                          "VALUES (?, ?, ?)");
            query.addBindValue(1001);
            query.addBindValue("Bart");
            query.addBindValue("Simpson");
            query.exec();

Binding values to a stored procedure:

This code calls a stored procedure called `AsciiToInt()`, passing it a character through its in parameter, and taking its result in the out parameter.

            QSqlQuery query = new QSqlQuery();
            query.prepare("CALL AsciiToInt(?, ?)");
            query.bindValue(0, "A");
            query.bindValue(1, 0, QSql.ParamTypeFlag.Out);
            query.exec();
            int i = query.boundValue(1).toInt(); // i is 65

Note that unbound parameters will retain their values.

Stored procedures that uses the return statement to return values, or return multiple result sets, are not fully supported. For specific details see SQL Database Drivers.

Warning: You must load the SQL driver and open the connection before a `QSqlQuery` is created. Also, the connection must remain open while the query exists; otherwise, the behavior of `QSqlQuery` is undefined.

See also:
  `QSqlDatabase`, `QSqlQueryModel`, `QSqlTableModel`, and `QVariant`.

Nested Class Summary
`static class` | `QSqlQuery.BatchExecutionMode`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Constructor Summary
`QSqlQuery()` Constructs a `QSqlQuery` object using the SQL `query` and the database `db`.
`QSqlQuery(QSqlDatabase db)` Constructs a `QSqlQuery` object using the database `db`.
`QSqlQuery(QSqlQuery other)` Constructs a copy of `other`.
`QSqlQuery(QSqlResult r)` Constructs a `QSqlQuery` object which uses the `QSqlResult` `result` to communicate with a database.
`QSqlQuery(java.lang.String query)` Constructs a `QSqlQuery` object using the SQL `query` and the database `db`.
`QSqlQuery(java.lang.String query, QSqlDatabase db)` Constructs a `QSqlQuery` object using the SQL `query` and the database `db`.

Method Summary
`void` | `addBindValue(java.lang.Object val)` Adds the value `val` to the list of values when using positional value binding.
`void` | `addBindValue(java.lang.Object val, QSql.ParamType type)` Adds the value `val` to the list of values when using positional value binding.
`void` | `addBindValue(java.lang.Object val, QSql.ParamTypeFlag[] type)` Adds the value `val` to the list of values when using positional value binding.
`int` | `at()` Returns the current internal position of the query.
`void` | `bindValue(int pos, java.lang.Object val)` Set the placeholder in position `pos` to be bound to value `val` in the prepared statement.
`void` | `bindValue(int pos, java.lang.Object val, QSql.ParamType type)` Set the placeholder in position `pos` to be bound to value `val` in the prepared statement.
`void` | `bindValue(int pos, java.lang.Object val, QSql.ParamTypeFlag[] type)` Set the placeholder in position `pos` to be bound to value `val` in the prepared statement.
`void` | `bindValue(java.lang.String placeholder, java.lang.Object val)` Set the placeholder `placeholder` to be bound to value `val` in the prepared statement.
`void` | `bindValue(java.lang.String placeholder, java.lang.Object val, QSql.ParamType type)` Set the placeholder `placeholder` to be bound to value `val` in the prepared statement.
`void` | `bindValue(java.lang.String placeholder, java.lang.Object val, QSql.ParamTypeFlag[] type)` Set the placeholder `placeholder` to be bound to value `val` in the prepared statement.
`java.lang.Object` | `boundValue(int pos)` Returns the value for the placeholder at position `pos`.
`java.lang.Object` | `boundValue(java.lang.String placeholder)` Returns the value for the `placeholder`.
`java.util.SortedMap` | `boundValues()` Returns a map of the bound values.
`void` | `clear()` Clears the result set and releases any resources held by the query.
`QSqlQuery` | `clone()` This method is reimplemented for internal reasons
`QSqlDriver` | `driver()` Returns the database driver associated with the query.
`boolean` | `exec()` Executes a previously prepared SQL query.
`boolean` | `exec(java.lang.String query)` Executes the SQL in `query`.
`boolean` | `execBatch()` Executes a previously prepared SQL query in a batch.
`boolean` | `execBatch(QSqlQuery.BatchExecutionMode mode)` Executes a previously prepared SQL query in a batch.
`java.lang.String` | `executedQuery()` Returns the last query that was successfully executed.
`void` | `finish()` Instruct the database driver that no more data will be fetched from this query until it is re-executed.
`boolean` | `first()` Retrieves the first record in the result, if available, and positions the query on the retrieved record.
`static QSqlQuery` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QSqlQuery instance pointed to by `nativePointer`.
`boolean` | `isActive()` Returns true if the query is currently active; otherwise returns false.
`boolean` | `isForwardOnly()` Returns true if you can only scroll forward through a result set; otherwise returns false.
`boolean` | `isNull(int field)` Returns true if the query is active and positioned on a valid record and the `field` is NULL; otherwise returns false.
`boolean` | `isSelect()` Returns true if the current query is a `SELECT` statement; otherwise returns false.
`boolean` | `isValid()` Returns true if the query is currently positioned on a valid record; otherwise returns false.
`boolean` | `last()` Retrieves the last record in the result, if available, and positions the query on the retrieved record.
`QSqlError` | `lastError()` Returns error information about the last error (if any) that occurred with this query.
`java.lang.Object` | `lastInsertId()` Returns the object ID of the most recent inserted row if the database supports it.
`java.lang.String` | `lastQuery()` Returns the text of the current query being used, or an empty string if there is no current query text.
`static QNativePointer` | `nativePointerArray(QSqlQuery[] array)` This function returns a QNativePointer that is pointing to the specified QSqlQuery array.
`boolean` | `next()` Retrieves the next record in the result, if available, and positions the query on the retrieved record.
`boolean` | `nextResult()` Discards the current result set and navigates to the next if available.
`QSql.NumericalPrecisionPolicy` | `numericalPrecisionPolicy()` Returns the current precision policy.
`int` | `numRowsAffected()` Returns the number of rows affected by the result's SQL statement, or -1 if it cannot be determined.
`boolean` | `prepare(java.lang.String query)` Prepares the SQL query `query` for execution.
`boolean` | `previous()` Retrieves the previous record in the result, if available, and positions the query on the retrieved record.
`QSqlRecord` | `record()` Returns a `QSqlRecord` containing the field information for the current query.
`QSqlResult` | `result()` Returns the result associated with the query.
`boolean` | `seek(int i)` Retrieves the record at position `index`, if available, and positions the query on the retrieved record.
`boolean` | `seek(int i, boolean relative)` Retrieves the record at position `index`, if available, and positions the query on the retrieved record.
`void` | `setForwardOnly(boolean forward)` Sets forward only mode to `forward`.
`void` | `setNumericalPrecisionPolicy(QSql.NumericalPrecisionPolicy precisionPolicy)` Instruct the database driver to return numerical values with a precision specified by `precisionPolicy`.
`int` | `size()` Returns the size of the result (number of rows returned), or -1 if the size cannot be determined or if the database does not support reporting information about query sizes.
`java.lang.Object` | `value(int i)` Returns the value of field `index` in the current record.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QSqlQuery

    public QSqlQuery(QSqlDatabase db)

  Constructs a `QSqlQuery` object using the database `db`.

See also:
  `QSqlDatabase`.

### QSqlQuery

    public QSqlQuery(QSqlResult r)

  Constructs a `QSqlQuery` object which uses the `QSqlResult` `result` to communicate with a database.

### QSqlQuery

    public QSqlQuery(QSqlQuery other)

  Constructs a copy of `other`.

### QSqlQuery

    public QSqlQuery(java.lang.String query)

  Constructs a `QSqlQuery` object using the SQL `query` and the database `db`. If `db` is not specified, the application's default database is used. If `query` is not an empty string, it will be executed.

See also:
  `QSqlDatabase`.

### QSqlQuery

    public QSqlQuery()

  Constructs a `QSqlQuery` object using the SQL `query` and the database `db`. If `db` is not specified, the application's default database is used. If `query` is not an empty string, it will be executed.

See also:
  `QSqlDatabase`.

### QSqlQuery

    public QSqlQuery(java.lang.String query,
                     QSqlDatabase db)

  Constructs a `QSqlQuery` object using the SQL `query` and the database `db`. If `db` is not specified, the application's default database is used. If `query` is not an empty string, it will be executed.

See also:
  `QSqlDatabase`.

Method Detail

### addBindValue

    public final void addBindValue(java.lang.Object val,
                                   QSql.ParamTypeFlag[] type)

  Adds the value `val` to the list of values when using positional value binding. The order of the `addBindValue()` calls determines which placeholder a value will be bound to in the prepared query. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `bindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### addBindValue

    public final void addBindValue(java.lang.Object val)

  Adds the value `val` to the list of values when using positional value binding. The order of the `addBindValue()` calls determines which placeholder a value will be bound to in the prepared query. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `bindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### addBindValue

    public final void addBindValue(java.lang.Object val,
                                   QSql.ParamType type)

  Adds the value `val` to the list of values when using positional value binding. The order of the `addBindValue()` calls determines which placeholder a value will be bound to in the prepared query. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `bindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### at

    public final int at()

  Returns the current internal position of the query. The first record is at position zero. If the position is invalid, the function returns `QSql::BeforeFirstRow` or `QSql::AfterLastRow` , which are special negative values.

See also:
  `previous()`, `next()`, `first()`, `last()`, `seek()`, `isActive()`, and `isValid()`.

### bindValue

    public final void bindValue(java.lang.String placeholder,
                                java.lang.Object val,
                                QSql.ParamTypeFlag[] type)

  Set the placeholder `placeholder` to be bound to value `val` in the prepared statement. Note that the placeholder mark (e.g `:`) must be included when specifying the placeholder name. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `addBindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### bindValue

    public final void bindValue(java.lang.String placeholder,
                                java.lang.Object val)

  Set the placeholder `placeholder` to be bound to value `val` in the prepared statement. Note that the placeholder mark (e.g `:`) must be included when specifying the placeholder name. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `addBindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### bindValue

    public final void bindValue(java.lang.String placeholder,
                                java.lang.Object val,
                                QSql.ParamType type)

  Set the placeholder `placeholder` to be bound to value `val` in the prepared statement. Note that the placeholder mark (e.g `:`) must be included when specifying the placeholder name. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

  To bind a NULL value, use a null `QVariant`; for example, use `QVariant(QVariant::String)` if you are binding a string.

See also:
  `addBindValue()`, `prepare()`, `exec()`, `boundValue()`, and `boundValues()`.

### bindValue

    public final void bindValue(int pos,
                                java.lang.Object val,
                                QSql.ParamTypeFlag[] type)

  Set the placeholder in position `pos` to be bound to value `val` in the prepared statement. Field numbering starts at 0. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

### bindValue

    public final void bindValue(int pos,
                                java.lang.Object val)

  Set the placeholder in position `pos` to be bound to value `val` in the prepared statement. Field numbering starts at 0. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

### bindValue

    public final void bindValue(int pos,
                                java.lang.Object val,
                                QSql.ParamType type)

  Set the placeholder in position `pos` to be bound to value `val` in the prepared statement. Field numbering starts at 0. If `paramType` is `QSql::Out` or `QSql::InOut` , the placeholder will be overwritten with data from the database after the `exec()` call.

### boundValue

    public final java.lang.Object boundValue(java.lang.String placeholder)

  Returns the value for the `placeholder`.

See also:
  `boundValues()`, `bindValue()`, and `addBindValue()`.

### boundValue

    public final java.lang.Object boundValue(int pos)

  Returns the value for the placeholder at position `pos`.

### boundValues

    public final java.util.SortedMap boundValues()

  Returns a map of the bound values.

  With named binding, the bound values can be examined in the following ways:

              Map<String, Object> map = query.boundValues();

              for (String key : map.keySet()) {
                  Object value = map.get(key);
                  System.out.println(i.key().toAscii().data() << ": "
                       << i.value().toString().toAscii().data());
              }

  With positional binding, the code becomes:

              int i = 0;
              for (Object value : query.boundValues().values())
                  System.err.println(String.valueOf(i++) + ": " + value);

See also:
  `boundValue()`, `bindValue()`, and `addBindValue()`.

### clear

    public final void clear()

  Clears the result set and releases any resources held by the query. You should rarely if ever need to call this function.

### driver

    public final QSqlDriver driver()

  Returns the database driver associated with the query.

### exec

    public final boolean exec()

  Executes a previously prepared SQL query. Returns true if the query executed successfully; otherwise returns false.

  Note that the last error for this query is reset when `exec()` is called.

See also:
  `prepare()`, `bindValue()`, `addBindValue()`, `boundValue()`, and `boundValues()`.

### exec

    public final boolean exec(java.lang.String query)

  Executes the SQL in `query`. Returns true and sets the query state to active if the query was successful; otherwise returns false. The `query` string must use syntax appropriate for the SQL database being queried (for example, standard SQL).

  After the query is executed, the query is positioned on an invalid record and must be navigated to a valid record before data values can be retrieved (for example, using `next()`).

  Note that the last error for this query is reset when `exec()` is called.

  Example:

              QSqlQuery query = new QSqlQuery();
              query.exec("INSERT INTO employee (id, name, salary) " +
                         "VALUES (1001, 'Thad Beaumont', 65000)");

See also:
  `isActive()`, `isValid()`, `next()`, `previous()`, `first()`, `last()`, and `seek()`.

### execBatch

    public final boolean execBatch()

  Executes a previously prepared SQL query in a batch. All the bound parameters have to be lists of variants. If the database doesn't support batch executions, the driver will simulate it using conventional `exec()` calls.

  Returns true if the query is executed successfully; otherwise returns false.

  Example:

              QSqlQuery q = new QSqlQuery();
              q.prepare("insert into myTable values (?, ?)");

          List<Integer> ints = new ArrayList<Integer>();
              ints.add(1);
          ints.add(2);
          ints.add(3);
          ints.add(4);
              q.addBindValue(ints);

          List<String> names = new ArrayList<String>();
          names.add("Harald");
          names.add("Boris");
          names.add("Trond");
          names.add(null);
              q.addBindValue(names);

              if (!q.execBatch())
                  System.out.println(q.lastError());

  The example above inserts four new rows into `myTable`:

          1  Harald
          2  Boris
          3  Trond
              4  NULL

  To bind NULL values, a null `QVariant` of the relevant type has to be added to the bound QVariantList; for example, `QVariant(QVariant::String)` should be used if you are using strings.

  Note that every bound QVariantList must contain the same amount of variants. Note that the type of the `QVariants` in a list must not change. For example, you cannot mix integer and string variants within a QVariantList.

  The `mode` parameter indicates how the bound QVariantList will be interpreted. If `mode` is `ValuesAsRows`, every variant within the QVariantList will be interpreted as a value for a new row. `ValuesAsColumns` is a special case for the Oracle driver. In this mode, every entry within a QVariantList will be interpreted as array-value for an IN or OUT value within a stored procedure. Note that this will only work if the IN or OUT value is a table-type consisting of only one column of a basic type, for example `TYPE myType IS TABLE OF VARCHAR(64) INDEX BY BINARY_INTEGER;`

See also:
  `prepare()`, `bindValue()`, and `addBindValue()`.

### execBatch

    public final boolean execBatch(QSqlQuery.BatchExecutionMode mode)

  Executes a previously prepared SQL query in a batch. All the bound parameters have to be lists of variants. If the database doesn't support batch executions, the driver will simulate it using conventional `exec()` calls.

  Returns true if the query is executed successfully; otherwise returns false.

  Example:

              QSqlQuery q = new QSqlQuery();
              q.prepare("insert into myTable values (?, ?)");

          List<Integer> ints = new ArrayList<Integer>();
              ints.add(1);
          ints.add(2);
          ints.add(3);
          ints.add(4);
              q.addBindValue(ints);

          List<String> names = new ArrayList<String>();
          names.add("Harald");
          names.add("Boris");
          names.add("Trond");
          names.add(null);
              q.addBindValue(names);

              if (!q.execBatch())
                  System.out.println(q.lastError());

  The example above inserts four new rows into `myTable`:

          1  Harald
          2  Boris
          3  Trond
              4  NULL

  To bind NULL values, a null `QVariant` of the relevant type has to be added to the bound QVariantList; for example, `QVariant(QVariant::String)` should be used if you are using strings.

  Note that every bound QVariantList must contain the same amount of variants. Note that the type of the `QVariants` in a list must not change. For example, you cannot mix integer and string variants within a QVariantList.

  The `mode` parameter indicates how the bound QVariantList will be interpreted. If `mode` is `ValuesAsRows`, every variant within the QVariantList will be interpreted as a value for a new row. `ValuesAsColumns` is a special case for the Oracle driver. In this mode, every entry within a QVariantList will be interpreted as array-value for an IN or OUT value within a stored procedure. Note that this will only work if the IN or OUT value is a table-type consisting of only one column of a basic type, for example `TYPE myType IS TABLE OF VARCHAR(64) INDEX BY BINARY_INTEGER;`

See also:
  `prepare()`, `bindValue()`, and `addBindValue()`.

### executedQuery

    public final java.lang.String executedQuery()

  Returns the last query that was successfully executed.

  In most cases this function returns the same string as `lastQuery()`. If a prepared query with placeholders is executed on a DBMS that does not support it, the preparation of this query is emulated. The placeholders in the original query are replaced with their bound values to form a new query. This function returns the modified query. It is mostly useful for debugging purposes.

See also:
  `lastQuery()`.

### finish

    public final void finish()

  Instruct the database driver that no more data will be fetched from this query until it is re-executed. There is normally no need to call this function, but it may be helpful in order to free resources such as locks or cursors if you intend to re-use the query at a later time.

  Sets the query to inactive. Bound values retain their values.

See also:
  `prepare()`, `exec()`, and `isActive()`.

### first

    public final boolean first()

  Retrieves the first record in the result, if available, and positions the query on the retrieved record. Note that the result must be in an active state and `isSelect()` must return true before calling this function or it will do nothing and return false. Returns true if successful. If unsuccessful the query position is set to an invalid position and false is returned.

See also:
  `next()`, `previous()`, `last()`, `seek()`, `at()`, `isActive()`, and `isValid()`.

### isActive

    public final boolean isActive()

  Returns true if the query is currently active; otherwise returns false.

### isForwardOnly

    public final boolean isForwardOnly()

  Returns true if you can only scroll forward through a result set; otherwise returns false.

See also:
  `setForwardOnly()`, and `next()`.

### isNull

    public final boolean isNull(int field)

  Returns true if the query is active and positioned on a valid record and the `field` is NULL; otherwise returns false. Note that for some drivers, `isNull()` will not return accurate information until after an attempt is made to retrieve data.

See also:
  `isActive()`, `isValid()`, and `value()`.

### isSelect

    public final boolean isSelect()

  Returns true if the current query is a `SELECT` statement; otherwise returns false.

### isValid

    public final boolean isValid()

  Returns true if the query is currently positioned on a valid record; otherwise returns false.

### last

    public final boolean last()

  Retrieves the last record in the result, if available, and positions the query on the retrieved record. Note that the result must be in an active state and `isSelect()` must return true before calling this function or it will do nothing and return false. Returns true if successful. If unsuccessful the query position is set to an invalid position and false is returned.

See also:
  `next()`, `previous()`, `first()`, `seek()`, `at()`, `isActive()`, and `isValid()`.

### lastError

    public final QSqlError lastError()

  Returns error information about the last error (if any) that occurred with this query.

See also:
  `QSqlError`, and `QSqlDatabase::lastError()`.

### lastInsertId

    public final java.lang.Object lastInsertId()

  Returns the object ID of the most recent inserted row if the database supports it. An invalid `QVariant` will be returned if the query did not insert any value or if the database does not report the id back. If more than one row was touched by the insert, the behavior is undefined.

  For MySQL databases the row's auto-increment field will be returned.

  Note: For this function to work in PSQL, the table table must contain OIDs, which may not have been created by default. Check the `default_with_oids` configuration variable to be sure.

See also:
  `QSqlDriver::hasFeature()`.

### lastQuery

    public final java.lang.String lastQuery()

  Returns the text of the current query being used, or an empty string if there is no current query text.

See also:
  `executedQuery()`.

### next

    public final boolean next()

  Retrieves the next record in the result, if available, and positions the query on the retrieved record. Note that the result must be in an active state and `isSelect()` must return true before calling this function or it will do nothing and return false.

  The following rules apply:

  - If the result is currently located before the first record, e.g. immediately after a query is executed, an attempt is made to retrieve the first record.
  - If the result is currently located after the last record, there is no change and false is returned.
  - If the result is located somewhere in the middle, an attempt is made to retrieve the next record.
  If the record could not be retrieved, the result is positioned after the last record and false is returned. If the record is successfully retrieved, true is returned.

See also:
  `previous()`, `first()`, `last()`, `seek()`, `at()`, `isActive()`, and `isValid()`.

### nextResult

    public final boolean nextResult()

  Discards the current result set and navigates to the next if available.

  Some databases are capable of returning multiple result sets for stored procedures or SQL batches (a query strings that contains multiple statements). If multiple result sets are available after executing a query this function can be used to navigate to the next result set(s).

  If a new result set is available this function will return true. The query will be repositioned on an invalid record in the new result set and must be navigated to a valid record before data values can be retrieved. If a new result set isn't available the function returns false and the the query is set to inactive. In any case the old result set will be discarded.

  When one of the statements is a non-select statement a count of affected rows may be available instead of a result set.

  Note that some databases, i.e. Microsoft SQL Server, requires non-scrollable cursors when working with multiple result sets. Some databases may execute all statements at once while others may delay the execution until the result set is actually accessed, and some databases may have restrictions on which statements are allowed to be used in a SQL batch.

See also:
  `QSqlDriver::hasFeature()`, `setForwardOnly()`, `next()`, `isSelect()`, `numRowsAffected()`, `isActive()`, and `lastError()`.

### numRowsAffected

    public final int numRowsAffected()

  Returns the number of rows affected by the result's SQL statement, or -1 if it cannot be determined. Note that for `SELECT` statements, the value is undefined; use `size()` instead. If the query is not active (`isActive()` returns false), -1 is returned.

See also:
  `size()`, and `QSqlDriver::hasFeature()`.

### numericalPrecisionPolicy

    public final QSql.NumericalPrecisionPolicy numericalPrecisionPolicy()

  Returns the current precision policy.

See also:
  `QSql::NumericalPrecisionPolicy` , and `setNumericalPrecisionPolicy()`.

### prepare

    public final boolean prepare(java.lang.String query)

  Prepares the SQL query `query` for execution. Returns true if the query is prepared successfully; otherwise returns false.

  The query may contain placeholders for binding values. Both Oracle style colon-name (e.g., `:surname`), and ODBC style (`?`) placeholders are supported; but they cannot be mixed in the same query. See the `Detailed Description` for examples.

  Portability note: Some databases choose to delay preparing a query until it is executed the first time. In this case, preparing a syntactically wrong query succeeds, but every consecutive `exec()` will fail.

  Example:

              QSqlQuery query = new QSqlQuery();
              query.prepare("INSERT INTO person (id, forename, surname) " +
                            "VALUES (:id, :forename, :surname)");
              query.bindValue(":id", 1001);
              query.bindValue(":forename", "Bart");
              query.bindValue(":surname", "Simpson");
              query.exec();

See also:
  `exec()`, `bindValue()`, and `addBindValue()`.

### previous

    public final boolean previous()

  Retrieves the previous record in the result, if available, and positions the query on the retrieved record. Note that the result must be in an active state and `isSelect()` must return true before calling this function or it will do nothing and return false.

  The following rules apply:

  - If the result is currently located before the first record, there is no change and false is returned.
  - If the result is currently located after the last record, an attempt is made to retrieve the last record.
  - If the result is somewhere in the middle, an attempt is made to retrieve the previous record.
  If the record could not be retrieved, the result is positioned before the first record and false is returned. If the record is successfully retrieved, true is returned.

See also:
  `next()`, `first()`, `last()`, `seek()`, `at()`, `isActive()`, and `isValid()`.

### record

    public final QSqlRecord record()

  Returns a `QSqlRecord` containing the field information for the current query. If the query points to a valid row (`isValid()` returns true), the record is populated with the row's values. An empty record is returned when there is no active query (`isActive()` returns false).

  To retrieve values from a query, `value()` should be used since its index-based lookup is faster.

  In the following example, a `SELECT * FROM` query is executed. Since the order of the columns is not defined, `QSqlRecord::indexOf()` is used to obtain the index of a column.

          QSqlQuery q = new QSqlQuery("select * from employees");
          QSqlRecord rec = q.record();

          System.out.println("Number of columns: " + rec.count());

          int nameCol = rec.indexOf("name"); // index of the field "name"
          while (q.next())
              System.out.println(q.value(nameCol).toString()); // output all names

See also:
  `value()`.

### result

    public final QSqlResult result()

  Returns the result associated with the query.

### seek

    public final boolean seek(int i)

  Retrieves the record at position `index`, if available, and positions the query on the retrieved record. The first record is at position 0. Note that the query must be in an active state and `isSelect()` must return true before calling this function.

  If `relative` is false (the default), the following rules apply:

  - If `index` is negative, the result is positioned before the first record and false is returned.
  - Otherwise, an attempt is made to move to the record at position `index`. If the record at position `index` could not be retrieved, the result is positioned after the last record and false is returned. If the record is successfully retrieved, true is returned.
  If `relative` is true, the following rules apply:
  - If the result is currently positioned before the first record or on the first record, and `index` is negative, there is no change, and false is returned.
  - If the result is currently located after the last record, and `index` is positive, there is no change, and false is returned.
  - If the result is currently located somewhere in the middle, and the relative offset `index` moves the result below zero, the result is positioned before the first record and false is returned.
  - Otherwise, an attempt is made to move to the record `index` records ahead of the current record (or `index` records behind the current record if `index` is negative). If the record at offset `index` could not be retrieved, the result is positioned after the last record if `index` >= 0, (or before the first record if `index` is negative), and false is returned. If the record is successfully retrieved, true is returned.

See also:
  `next()`, `previous()`, `first()`, `last()`, `at()`, `isActive()`, and `isValid()`.

### seek

    public final boolean seek(int i,
                              boolean relative)

  Retrieves the record at position `index`, if available, and positions the query on the retrieved record. The first record is at position 0. Note that the query must be in an active state and `isSelect()` must return true before calling this function.

  If `relative` is false (the default), the following rules apply:

  - If `index` is negative, the result is positioned before the first record and false is returned.
  - Otherwise, an attempt is made to move to the record at position `index`. If the record at position `index` could not be retrieved, the result is positioned after the last record and false is returned. If the record is successfully retrieved, true is returned.
  If `relative` is true, the following rules apply:
  - If the result is currently positioned before the first record or on the first record, and `index` is negative, there is no change, and false is returned.
  - If the result is currently located after the last record, and `index` is positive, there is no change, and false is returned.
  - If the result is currently located somewhere in the middle, and the relative offset `index` moves the result below zero, the result is positioned before the first record and false is returned.
  - Otherwise, an attempt is made to move to the record `index` records ahead of the current record (or `index` records behind the current record if `index` is negative). If the record at offset `index` could not be retrieved, the result is positioned after the last record if `index` >= 0, (or before the first record if `index` is negative), and false is returned. If the record is successfully retrieved, true is returned.

See also:
  `next()`, `previous()`, `first()`, `last()`, `at()`, `isActive()`, and `isValid()`.

### setForwardOnly

    public final void setForwardOnly(boolean forward)

  Sets forward only mode to `forward`. If `forward` is true, only `next()` and `seek()` with positive values, are allowed for navigating the results.

  Forward only mode can be (depending on the driver) more memory efficient since results do not need to be cached. It will also improve performance on some databases. For this to be true, you must call `setForwardMode()` before the query is prepared or executed. Note that the constructor that takes a query and a database may execute the query.

  Forward only mode is off by default.

See also:
  `isForwardOnly()`, `next()`, and `seek()`.

### setNumericalPrecisionPolicy

    public final void setNumericalPrecisionPolicy(QSql.NumericalPrecisionPolicy precisionPolicy)

  Instruct the database driver to return numerical values with a precision specified by `precisionPolicy`.

  The Oracle driver, for example, retrieves numerical values as strings by default to prevent the loss of precision. If the high precision doesn't matter, use this method to increase execution speed by bypassing string conversions.

  Note: Drivers that don't support fetching numerical values with low precision will ignore the precision policy. You can use `QSqlDriver::hasFeature()` to find out whether a driver supports this feature.

  Note: Setting the precision policy doesn't affect the currently active query. Call `exec(QString)` or `prepare()` in order to activate the policy.

See also:
  `QSql::NumericalPrecisionPolicy` , and `numericalPrecisionPolicy()`.

### size

    public final int size()

  Returns the size of the result (number of rows returned), or -1 if the size cannot be determined or if the database does not support reporting information about query sizes. Note that for non-`SELECT` statements (`isSelect()` returns false), `size()` will return -1. If the query is not active (`isActive()` returns false), -1 is returned.

  To determine the number of rows affected by a non-`SELECT` statement, use `numRowsAffected()`.

See also:
  `isActive()`, `numRowsAffected()`, and `QSqlDriver::hasFeature()`.

### value

    public final java.lang.Object value(int i)

  Returns the value of field `index` in the current record.

  The fields are numbered from left to right using the text of the `SELECT` statement, e.g. in

              SELECT forename, surname FROM people;

  field 0 is `forename` and field 1 is `surname`. Using `SELECT *` is not recommended because the order of the fields in the query is undefined.

  An invalid `QVariant` is returned if field `index` does not exist, if the query is inactive, or if the query is positioned on an invalid record.

See also:
  `previous()`, `next()`, `first()`, `last()`, `seek()`, `isActive()`, and `isValid()`.

### fromNativePointer

    public static QSqlQuery fromNativePointer(QNativePointer nativePointer)

  This method returns the QSqlQuery instance pointed to by `nativePointer`.

### nativePointerArray

    public static QNativePointer nativePointerArray(QSqlQuery[] array)

  This function returns a QNativePointer that is pointing to the specified QSqlQuery array.

### clone

    public QSqlQuery clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD